/*
 * Project name:
     TFT_Backlight.vtft
     
 * Generated by:
     Visual TFT
     
 * Date of creation
     18.04.2014
     
 * Author:
     John Code / johncode666@hotmail.com
     
 * Test configuration:
     MCU:             P18F87J50
     Dev.Board:       MikroMMB_for_PIC18FJ_hw_rev_1.05
     Oscillator:      48000000 Hz
     SW:              mikroC PRO for PIC

 */


#include "TFT_Backlight_objects.h"
#include "header.h"


unsigned char uchOnCounter = 0, uchOffCounter = 0;
unsigned char uchPosition = 0;
unsigned char uchActualScreen = 1;



void interrupt(){
   if(TMR2IF_bit == 1){  /* every 125us */
      TMR2IF_bit = 0; 
      uchOnCounter++;
      uchOffCounter++;
      
      if((uchPosition == 100) && (uchActualScreen == 1)){
         BACKLIGHT_LAT_BIT = 1;
      }
      else if(uchActualScreen == 1){
         if((uchOnCounter >= uchPosition) && (BACKLIGHT_LAT_BIT == 1)){
            uchOnCounter = 0;
            BACKLIGHT_LAT_BIT = 0;
            uchOffCounter = 0;
         }
         else if((uchOffCounter >= (100 - uchPosition)) && (BACKLIGHT_LAT_BIT == 0)){
            uchOffCounter = 0;
            BACKLIGHT_LAT_BIT = 1;
            uchOnCounter = 0;
         }
      }
   } /* TMR2IF */
} /* interrupt */


void main(){
   ANCON0  = 0xFF;    // default all pins to digital
   ANCON1  = 0xFF;
   CM1CON  = 0;       // turn off comparators
   CM2CON  = 0;
   PLLEN_bit = 1;     // PLL osc
   
   BACKLIGHT_TRIS_BIT = 0;  // output
   BACKLIGHT_LAT_BIT  = 1;  // backlight on
   
   /* init Timer2: actual interrupt time : 125 us */
   T2CON      = 0x2C;   // prescaler 1:1
   TMR2IE_bit = 1;
   PR2        = 249;    // TMR2 preload
   INTCON     = 0xC0;
   
   Start_TP();
   uchPosition = (unsigned char) ProgressBar1.Position;
   
   while(1){
      Check_TP();
      
   } /* while */
} /* main */