typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef const struct  CButton {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  const char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCButton;

typedef const struct  CButton_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  const char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCButton_Round;

typedef const struct  CLabel {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCLabel;

typedef struct ProgressBar {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Transparent;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  unsigned int  Background_Color;
  unsigned int  Min;
  unsigned int  Max;
  unsigned int  Position;
  char          Show_Position;
  char          Show_Percentage;
  char          Smooth;
  char          Rounded;
  char          Corner_Radius;
} TProgressBar;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           CButtonsCount;
  TCButton               * const code *CButtons;
  unsigned int           CButtons_RoundCount;
  TCButton_Round         * const code *CButtons_Round;
  unsigned int           CLabelsCount;
  TCLabel                * const code *CLabels;
  unsigned int           ProgressBarsCount;
  TProgressBar           * const code *ProgressBars;
};

extern   TScreen                Screen1;
extern   TCButton_Round          Button1;
extern   TCButton_Round          Button2;
extern   TProgressBar                 ProgressBar1;
extern   TCButton_Round          Button3;
extern   TCLabel          Label1;
extern   TCButton_Round         * const code Screen1_CButtons_Round[3];
extern   TCLabel                * const code Screen1_CLabels[1];
extern   TProgressBar           * const code Screen1_ProgressBars[1];

extern   TScreen                Screen2;
extern   TCButton                Button4;
extern   TCButton               * const code Screen2_CButtons[1];


/////////////////////////
// Events Code Declarations
void Button3OnClick();
void Button4OnClick();
void ButtonDwnClick();
void ButtonUpClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern const char Button1_Caption[];
extern const char Button2_Caption[];
extern char ProgressBar1_Caption[];
extern const char Button3_Caption[];
extern const char Label1_Caption[];
extern const char Button4_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawCButton(TCButton *aCButton);
void DrawCRoundButton(TCButton_Round *ACround_button);
void DrawCLabel(TCLabel *AClabel);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
